; Copyright (c) 1991-1994, John David Rohner.  All rights reserved.

;
; This routine uses gets the ASCII value of right-most character of a string.
;
; Usage:  Result% = AscRight(Input$)
;
; Where Input$ is the text to to analyze, and Result% contains the value
; itself.  
;
; Will return 0 if you feed it a null string.
;
; It's a faster replacement for ASC(RIGHT$(Input$,1)).
;

.Model Medium, Basic
.Code

            PUBLIC  AscRight          ;Make this routine available to LINK.

            extrn   StringAddress: proc
            extrn   StringLength: proc

AscRight    proc    far

            push    bp
            mov     bp,sp

            mov     ax,[bp + 06]
            push    ax
            push    ax
            call    StringLength
            xchg    ax,di
            call    StringAddress
            xchg    ax,si

            xor     ax,ax
            mov     bx,di
            dec     bx
            js      Done

            mov     es,dx
            mov     al,es:[si + bx]

      Done: pop     bp
            ret     2                 ;Pop-return past our input parameters.

AscRight    endp                      ;End of routine.

End

