' $INCLUDE: 'JDRBBS.INC'
'
' Copyright (c) 1991-1994, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will get a character from the user.
        '
        ' p$  list of valid/accepted keys.
        '     The following are special attention codes:
        '       ASCII 1 means to accept a protocol auto-detect string.
        '       ASCII 2 don't do the usual purge of I/O after a valid key.
        '       ASCII 3 means to use the LOGO inactivity delay
        '       ASCII 4 means to also check for arrow keys.
        '               TGot$ may contain anything, so don't use.  Calling
        '               routine must be able to handle the 4 arrow key codes.
        '       ASCII 5 means to accept <ctrl>Fx keys.
        '       ASCII 6 means to allow <alt>c for chat.
        '
        ' TGot$/TGot returns with the valid key hit, an [Enter] or loss
        ' of carrier will return a NULL and -1, respectively.
        ' TGot$ may also contain the special purpose output strings
        ' ZMODEM and BIMODEM for when the auto-detect sequence related
        ' to these protocols was detected.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB TGet (p$)

  kz = 0
  K0$ = p$
  K2 = 0
  FOR K = 1 TO 6
    K0 = StrSrch1(K0$,K)
    IF K0 > 0 THEN CALL BitSet(K2,K) : _
                   K0$ = LEFT$(K0$,K0 - 1) + MID$(K0$,K0 + 1)
  NEXT
  IF BitTest(K2,3) THEN K1 = Settings.LogoTimeOut * 100 _
                   ELSE K1 = Settings.Timeout * 100
  K0 = K1 - 70
  K1$ = TIME$
  DO
    '
    ' Check our inactivity.
    '
    K = ElapsedTime(K1$,K3)
    IF UserSL = LevelsSize THEN K = 0 : _
                                K3 = 0
    SELECT CASE K * 100 + K3
      CASE K1
           CALL Quote(0)
           TGot = 13
           EXIT DO
      CASE K0
           TT$ = Lines$(172) + STR$(K1 - 40 - K0) + Lines$(173)
           CALL CommOut(TT$)
           CALL AnsiTT
           K0 = K0 + 10
    END SELECT
    '
    ' Check the keyboard and the port.
    '
    IF BitTest(K2,6) THEN z2 = 32 + 256 _
                     ELSE z2 = 32
    IF BitTest(K2,4) THEN z2 = z2 + 1
    IF NOT BitTest(K2,5) THEN TGot = CommIn(z2 + 4) _
                         ELSE TGot = CommIn(z2) : _
                              IF TGot > 24000 THEN EXIT DO
    SELECT CASE BitTest(K2,4)
      CASE -1
           SELECT CASE TGot
             CASE LeftSC, UpSC, RightSC, DownSC : kz = 1
                                                  EXIT DO
           END SELECT
    END SELECT

    '
    ' Check incoming protocol auto-detect strings.
    '
    SELECT CASE BitTest(K2,1)
      CASE -1
           '
           ' Check BiModem auto upload string: '' (also + '')
           '
           K = 1
           WHILE TGot = AscMid(Short$(183),K) AND K < 5
             DO : TGot = CommIn(0)
             LOOP UNTIL TGot >= 0 OR NoCarrier
             K = K + 1
           WEND
           IF K = 5 THEN TGot$ = Short$(187) : _
                         TGot = 1 : _
                         kz = 1 : _
                         EXIT DO
           '
           ' Check HS/Link auto upload string: '<ASCII 2>R'
           '
           K = 1
           K11$ = C2$ + Chars$(82)
           WHILE TGot = AscMid(K11$,K) AND K < 3
             DO : TGot = CommIn(0)
             LOOP UNTIL TGot >= 0 OR NoCarrier
             K = K + 1
           WEND
           IF K = 3 THEN TGot$ = Short$(230) : _
                         TGot = 1 : _
                         kz = 1 : _
                         EXIT DO
           '
           ' Check ZModem auto upload string:
           '        'rz<ASCII 13>**<ASCII 24>B' (also + '0...')
           '
           SELECT CASE TGot
             CASE 114
                  '
                  ' We have an 'r', but since menu commands also start with 'r',
                  ' we need to get the next character.  What I did was just grab
                  ' the next port check.  This could/may be too fast on faster
                  ' machines or with HST's.  If so, add some sort of delay--such
                  ' as looping for 100 iterations to see if another character
                  ' comes down the line--because 'r' menu commands won't have
                  ' any other characters.
                  '
                  K = CommIn(0)
                  IF K >= 0 THEN TGot = K
                  K = 2
                  K11$ = Short$(207) + C13$ + Short$(210) + Chars$(24) + Chars$(66)
                  WHILE TGot = AscMid(K11$,K) AND K < 8
                    DO : TGot = CommIn(0)
                    LOOP UNTIL TGot >= 0 OR NoCarrier
                    K = K + 1
                  WEND
                  IF K = 8 THEN TGot$ = Short$(225) : _
                                TGot = 1 : _
                                kz = 1 : _
                                EXIT DO
           END SELECT
    END SELECT
    IF TGot = 127 THEN TGot = 8
    IF TGot > 96 THEN CALL BitClear(TGot,6) _
                 ELSE IF TGot < 0 THEN TGot = 0
  LOOP UNTIL StrSrch1(K0$,TGot) > 0 OR NoCarrier
  IF TGot > 24000 OR kz = 1 THEN EXIT SUB
  TGot$ = Chars$(TGot)
  IF TGot = 13 OR NoCarrier THEN TGot$ = Null$ : _
                                 TGot = -1
  IF NOT BitTest(K2,2) THEN CALL PurgeComIO(CommPort)

END SUB
        '
        '* * * *

'just like tget, but instead of tgot returning the ASCII value, it returns the
'position in the original search string.
SUB TGet2 (p$)

  CALL TGet(p$)
  IF TGot > 0 THEN TGot = StrSrch1(p$,TGot)

END SUB
